<script setup lang="ts">
    import { WritableComputedRef, computed, ref } from 'vue'
    import { VInput } from 'vuetify/lib/components/index.mjs'

    //Je n'arrive pas à importer le type des rules (ValidationRule$1) de vuetifie, le type any est donc utilisé à la place
    interface Props {
        modelValue: object | undefined
        label: string
        jsonHelp: string
        // eslint-disable-next-line
        jsonHelpDescription?: string
        dataCy: string
        rules?: VInput['rules']
    }

    const props = withDefaults(defineProps<Props>(), {
        rules: () => [],
    })

    const emit = defineEmits<{
        'update:modelValue': [value: JSON]
    }>()

    const getObjectToStringAndSetStringToJson: WritableComputedRef<string> =
        computed({
            get() {
                return transformObjectTostring(props.modelValue)
            },
            set(string: string) {
                emit('update:modelValue', transformStringToJSON(string))
            },
        })

    function transformObjectTostring(value: object | undefined) {
        return JSON.stringify(value) !== '[]' ? JSON.stringify(value) : '{}'
    }

    function transformStringToJSON(value: string) {
        try {
            return JSON.parse(value)
        } catch {
            return undefined
        }
    }

    function textMustBeValidJson(input: string) {
        try {
            JSON.parse(input)
        } catch (e) {
            if (!(e instanceof SyntaxError)) {
                throw e
            }
            return 'Le json entré est invalide'
        }

        return true
    }

    const showJsonHelp = ref(false)
    const toggleJsonHelp = () => {
        showJsonHelp.value = !showJsonHelp.value
    }
</script>

<template>
    <v-alert
        v-if="showJsonHelp"
        variant="outlined"
        border="start"
        class="mb-6"
        icon="mdi-help-circle-outline"
        title="Exemple de Json attendu"
    >
        <code
            style="
                white-space: pre;
                display: block;
                margin: 0.5em;
                padding: 0.8em;
                overflow-x: auto;
                background-color: rgb(231, 231, 231);
                border-radius: 10px;
            "
            >{{ props.jsonHelp }}</code
        >
        <p>{{ props.jsonHelpDescription }}</p>
    </v-alert>

    <v-textarea
        v-model="getObjectToStringAndSetStringToJson"
        :label="label"
        variant="outlined"
        class="mb-3"
        :rules="rules.concat(textMustBeValidJson)"
        :data-cy="dataCy"
        hide-details="auto"
        :append-inner-icon="
            showJsonHelp ? 'mdi-close' : 'mdi-help-circle-outline'
        "
        v-bind="$attrs"
        auto-grow
        @click:append-inner="toggleJsonHelp"
    ></v-textarea>
</template>
